#include <iostream>
#include "mysql++.h"

using namespace mysqlpp;
using namespace std;

Connection con(use_exceptions);
Query qu_e = con.query();
Result sql_res;
STRING *error_data;
STRING *t34;	//mysql username
STRING *t35;	//mysql password
STRING *t36;	//mysql host
STRING *t37;	//mysql database
struct mystruct{
	char *results;
};
std::vector<mystruct> d492;

DLLFUNC var mysql__connect(STRING *host, STRING *username, STRING *passwd, STRING *db)
{
	try{
		con.connect(db->chars, host->chars, username->chars, passwd->chars);
		if(!con.connected())
			return _VAR(0);
		/*str_cpy(t34, username->chars);	//copy username
		str_cpy(t35, passwd->chars);	//copy password
		str_cpy(t36, host->chars);		//copy host
		str_cpy(t37, db->chars);		//copy db*/
	}
	catch (BadQuery& er) { // handle any connection or
                          // query errors that may come up
		return _VAR(0);
	}
	return _VAR(1);
}

DLLFUNC var mysql__connected()
{
	if(con.connected())
		return _VAR(1);
	else
		return _VAR(0);
}

DLLFUNC var mysql__success()
{
	if((qu_e.success()) == true)
		return _VAR(1);
	else
		return _VAR(0);
}
STRING *res_query;
DLLFUNC var mysql__query(STRING *sql)
{
	if(!con.connected())
		return _VAR(0);

	qu_e << sql->chars;
	try{
		sql_res = qu_e.store();
	}
	catch(BadQuery er){
		return _VAR(0);
	}
	return _VAR(1); 
}

DLLFUNC var mysql__result(STRING *dest, STRING *field, var y)
{
	try{
		int x = sql_res.field_num(field->chars);
		string my_str((sql_res[_INT(y)])[_INT(_VAR(x))]);
		my_str+='\0';
		if(dest->length >= my_str.length())
			strcpy(dest->chars,my_str.c_str());
		else return _VAR(-2);
	}
	catch (BadQuery& er) {
	return _VAR(0);
	}
	catch (BadConversion& er) {
	return _VAR(-1);
	}
  return _VAR(1);
}

DLLFUNC var mysql__select__db(STRING *db)
{
	if(!con.connected())
		return _VAR(0);

	try{
		if((con.select_db(db->chars)) == true)
			return _VAR(1);
	}
	catch(BadQuery& er)
	{
		return _VAR(0);
	}
}

DLLFUNC var mysql__create__db(STRING *db2)
{
	if(!con.connected())
		return _VAR(0);

	qu_e.reset();
	qu_e << "CREATE database " << db2->chars;
	try{
		sql_res = qu_e.store();	
		if(!qu_e.success())
			return (0);
	}
	catch(BadQuery& er)
	{
		return _VAR(0);
	}
	return _VAR(1);
}

DLLFUNC var mysql__affected__rows()
{
	if(!con.connected())
		return _VAR(-1);
	
	return ((var)con.affected_rows());
}

DLLFUNC var mysql__num__rows()
{
	if(!con.connected())
		return _VAR(-1);

	return ((var)sql_res.num_rows());
}

DLLFUNC var mysql__num__fields()
{
	if(!con.connected())
		return _VAR(-1);

	return _VAR(sql_res.num_fields());
}

DLLFUNC var mysql__change__user(STRING *new_user, STRING *new_passwd, STRING *db)
{
	if(!con.connected())
		return _VAR(-1);

	try{
		con.close();
		con.connect(db->chars, t36->chars, new_user->chars, new_passwd->chars);
		if(!con.connected())
			return _VAR(-1);
	}
	catch (BadQuery& er) { // handle any connection or
                          // query errors that may come up
		return _VAR(-1);
	}
	return _VAR(0);
}

DLLFUNC var mysql__close()
{
	if(!con.connected())
		return _VAR(0);

	con.close();
	if(con.connected())
		return _VAR(0);

	return _VAR(1);
}

DLLFUNC var mysql__data__seek(var row)
{
	if(!con.connected())
		return _VAR(-1);

	sql_res.data_seek(row);
	return _VAR(0);
}

DLLFUNC var mysql__db__query(STRING *db, STRING *query)
{
	if(!con.connected())
		return _VAR(-1);
	con.select_db(db->chars);
	qu_e.reset();
	qu_e << query->chars;
	try{
		sql_res = qu_e.store();
	}
	catch (BadQuery& er) { // handle any connection or
                          // query errors that may come up
		return _VAR(-1);
	}
	return _VAR(0);
}

DLLFUNC var mysql__drop__db(STRING *db)
{
	if(!con.connected())
		return _VAR(0);

	qu_e << "DROP DATABASE " << db->chars;
	try{
		sql_res = qu_e.store();
	}
	catch (BadQuery& er) { // handle any connection or
                          // query errors that may come up
		return _VAR(0);
	}
	return _VAR(1);
}
DLLFUNC var mysql__errno()
{
	if(!con.connected())
		return _VAR(0);

	return _VAR(con.errnum());
}

DLLFUNC STRING *mysql__error()
{
	return((STRING*)con.error());
}

DLLFUNC var mysql__ping()
{
	return _VAR(con.ping());
}

DLLFUNC var mysql__proto__info()
{
	return _VAR(con.proto_info());
}

DLLFUNC void mysql__purge()
{
	con.purge();
}

var port;
var compress;
var timeout;
STRING *socket_name;
var client_flag;

DLLFUNC var mysql__real__connect(STRING *db, STRING *host, STRING *user, STRING *passwd)
{
	try{
		con.real_connect(db->chars, host->chars, user->chars, passwd->chars, port, compress, timeout, socket_name->chars, client_flag);
		if(con.connected())
			return _VAR(1);
	}
	catch(BadQuery er)
	{
		return _VAR(0);
	}
}

DLLFUNC var mysql__refresh(var refresh_options)
{
	return _VAR(con.refresh(refresh_options));
}

DLLFUNC var mysql__reload()
{
	if((con.reload()) == false)
		return _VAR(0);

	return _VAR(1);
}

DLLFUNC var mysql__shutdown()
{
	if((con.shutdown()) == false)
		return _VAR(0);

	return _VAR(1);
}

DLLFUNC STRING *mysql__get__client__info()
{
	return((STRING*)con.client_info());
}

DLLFUNC STRING *mysql__get__host__info()
{
	return((STRING*)con.host_info());
}

DLLFUNC STRING *mysql__get__server__info()
{
	return((STRING*)con.server_info());
}

DLLFUNC STRING *mysql__get__stat()
{
	return((STRING*)con.stat());
}